""" File to contain in a single file all configurations of logging """

import logging

from utils.file_handling import create_folders, file_exists, full_path_file

def setup_logger(output_folder: str, debug: bool):
    """ Setup basic configuration for logging """
    #logging.getLogger("httpx").setLevel(logging.WARNING)
    level = logging.INFO
    if debug:
        level = logging.DEBUG
    filename = full_path_file(output_folder, "extractor.log")
    if not file_exists(filename):
        create_folders(output_folder)
    logging.basicConfig(format='%(asctime)s - %(name)s - %(levelname)s - %(message)s',
                        level=level,
                        filename=filename
                        )
    
    
def get_logger(name="MAIN"):
    """ Get a named logger """
    return logging.getLogger(name)
