"""Master Data models."""
from datetime import datetime

from pydantic import BaseModel, Field, validator
from typing import Optional


class Uoms(BaseModel):
    UniqueName: Optional[str]
    Description_en: Optional[str]


class CompanyCodes(BaseModel):
    UniqueName: Optional[str]
    Description: Optional[str]


class PurchaseGroups(BaseModel):
    UniqueName: Optional[str]
    Name: Optional[str]


class PurchaseOrgs(BaseModel):
    UniqueName: Optional[str]
    Name: Optional[str]


class Countries(BaseModel):
    UniqueName: Optional[str]
    Name_en: Optional[str]


class Suppliers(BaseModel):
    UniqueName: Optional[str]
    IsOneTimeVendorShell: Optional[str]


class Users(BaseModel):
    UniqueName: Optional[str]
    Name_en: Optional[str]
    PasswordAdapter: Optional[str]


class Paymentterms(BaseModel):
    UniqueName: Optional[str]
    Description_en: Optional[str]


class MasterData(BaseModel):
    uoms: Optional[Uoms]
    companycodes: Optional[CompanyCodes]
    purchasegroups: Optional[PurchaseGroups]
    purchseorgs: Optional[PurchaseOrgs]
    countries: Optional[Countries]
    suppliers: Optional[Suppliers]
    users: Optional[Users]
    paymentterms: Optional[Paymentterms]
