"""MasterDataRetrievalForSourcing models."""
from typing import Optional
from pydantic import BaseModel, validator


class CurrencyConversionRate(BaseModel):
    """CurrencyConversionRate model."""

    FromCurrency: Optional[str]
    Rate: Optional[str]
    TimeCreated: Optional[str]
    ToCurrency: Optional[str]

    @validator("Rate", pre=True, always=True)
    def get_rate_in_numerical_format(cls, value):
        if not value:
            return ""
        value = float(value)
        return f"{value:.10f}"
