""" Base class that defines behaviour of all view parsers."""
from abc import ABC, abstractmethod


class BaseParser(ABC):
    def get_id_field(cls):
        """ By default doesn't return a id field. If the implementation has one, it must override this method."""
        return None
    
    @abstractmethod
    def parse_item(cls, item):
        """ Parse an item and return an object compatible with associated models and tables."""
        