from models.operational_reporting_procurement.invoice_reconciliation import InvoiceReconciliation_Header, InvoiceReconciliation_Payments
from utils.object_parsing import get_hierarchy
from view_parsers.base import BaseParser


class Invoice_reconciliation_parser(BaseParser):
    """ Parser for a InvoiceReconciliation_SAP_updatedRange viewTemplate."""
    @classmethod
    def parse_item(cls, item):
        InvoiceReconciliation_Header_id = item.get("UniqueName", None)
        TimeUpdated = item.get("TimeUpdated", None)
        header = {}
        header["InvoiceReconciliation_Header_id"] = InvoiceReconciliation_Header_id
        header["ApprovedDate"] = item.get("ApprovedDate", None)
        header["CreateDate"] = item.get("CreateDate", None)
        header["Invoice"] = get_hierarchy(item, "Invoice", "UniqueName") #item.get("Invoice").get("UniqueName", None) if item.get("Invoice", None) is not None else None
        header["PaidDate"] = item.get("PaidDate", None)
        header["RejectedDate"] = item.get("RejectedDate", None)
        header["ResubmitDate"] = item.get("ResubmitDate", None)
        header["StatusString"] = item.get("StatusString", None)
        header["SubmitDate"] = item.get("SubmitDate", None)
        header["TimeUpdated"] = TimeUpdated
        Header = InvoiceReconciliation_Header(**header)

        payments_list = []
        Payments = item.get("Payments", [])

        for line in Payments:
            payment = {}
            payment["InvoiceReconciliation_Header_id"] = InvoiceReconciliation_Header_id
            payment["UniqueName"] = line.get("UniqueName", None)
            payment["NetDueDate"] = line.get("NetDueDate", None)    
            # Each payment doesn't have a udpate date, so using main one
            payment["TimeUpdated"] = TimeUpdated
            payments_list.append(InvoiceReconciliation_Payments(**payment))        
        
        return {"InvoiceReconciliation_Header": [Header], "InvoiceReconciliation_Payments": payments_list}